'use strict';

/**
 * DOM manipulation functions
 */

function setStage(stage) {
	const elements = document.getElementsByClassName("stage");
	for ( let i=0; i<elements.length; i++ ) {
		const elm = elements[i];
		if (elm.id != stage)
			elm.classList.add('d-none');
		else
			elm.classList.remove('d-none');
	}
}

function showAllocation(team) {
	const label = document.getElementById("team-id");
	label.textContent = team.groupID;
	setStage('stage-allocated');
}

function changeName(){
	const newName = document.getElementById("input-name").value;
	alloc.setName( newName );
	setStage( 'stage-wait' );
	return false;
}

function onStartAllocate() {
	alloc.forceAllocate();
}

/**
 * Websocket functions
 */

let alloc = null;
class AllocatorToy {
	constructor(ws) {
		this.ws = ws;
		ws.onopen = this.onConnect;
		ws.onmessage = this.onMessage;
	}
	onConnect() {
		setStage('stage-name');
		const nameStage = document.getElementById("stage-name");
		nameStage.classList.remove('d-none');
	}
	onMessage(evt) {
		let msg = JSON.parse(evt.data);
		console.log( msg );
		switch ( msg.type ) {
			case 'allocate':
				showAllocation( msg.data );
				break;
		}
	}
	send(type, payload) {
		const msg = {
			'type': type,
			'data': payload
		};
		this.ws.send( JSON.stringify( msg ) );
	}
	setName(name){
		this.send( 'changeName', { 'name': name } );
	}
	forceAllocate() {
		this.send( 'forceAllocate', {} );
		console.log("allocation requested");
	}
};


function start() {
	const ws = new WebSocket('ws://localhost:8081');
	alloc = new AllocatorToy( ws );
}




